format PE GUI 4.0
entry MyEntry

include '\Program Files\fasm\include\macro\masm.inc'
include '\Program Files\fasm\include\Win32axp.inc'

macro iglobal { IGlobals equ IGlobals,
      macro __IGlobalBlock { }

macro uglobal { UGlobals equ UGlobals,
      macro __UGlobalBlock { }

endg fix }

macro IncludeIGlobals { macro IGlobals dummy,[n] \{ __IGlobalBlock
		      purge __IGlobalBlock \}
		      match I, IGlobals \{ I \} }


macro IncludeUGlobals { macro UGlobals dummy,[n] \{ \common \local begin, size
						     begin = $
						     virtual at $
						    \forward
						     __UGlobalBlock
						     purge __UGlobalBlock
						    \common
						     size = $ - begin
						     end virtual
						     rb size \}
			match U, UGlobals \{ U \} }

macro IncludeAllGlobals { IncludeIGlobals
			  align 4
			  IncludeUGlobals }

;Initialized data
iglobal
ClassName	db	"SimpleWinClass", 0
AppName 	db	"Tab2Windows", 0
ComboName	db	"ComboBox", 0
ListName	db	"SysListView32", 0
EditName	db	"Edit", 0
ButtonName	db	"Button", 0
szButtonPressed db	"Button Pressed", 0
szFirst 	db	"First", 0
szSecond	db	"Second", 0
szThird 	db	"Thitd", 0
szFourth	db	"Fourth", 0
szFifth 	db	"Fifth", 0
sz8		db	"8.0", 0
szNone		db	"None", 0
ButtonText	db	"Go", 0
CheckText	db	"Select All", 0
endg

;UnItialized data
uglobal
gIst	dd	?
gWnd	dd	?
gHwnd	dd	?
hAccel	dd	?
hCB1	dd	?
hLV1	dd	?
hEdit1	dd	?
hButn	dd	?
hCheck	dd	?
align	4
msg			MSG
align	4
wc			WNDCLASSEX
endg

section '.code' code readable executable
MyEntry:
	invoke	GetModuleHandle, eax
	mov		[gIst], eax
	invoke	InitCommonControls
	mov		[wc.cbSize], sizeof.WNDCLASSEX
	mov		[wc.style], CS_HREDRAW or CS_VREDRAW or WS_TABSTOP
	mov		[wc.lpfnWndProc], WndProc
	mov		[wc.cbClsExtra], NULL
	mov		[wc.cbWndExtra], NULL
	push	[gIst]
	pop		[wc.hInstance]
	mov		[wc.hbrBackground], COLOR_BTNFACE + 1
	mov		[wc.lpszMenuName], NULL
	mov		[wc.lpszClassName],  ClassName
	invoke	LoadIcon, NULL, IDI_APPLICATION
	mov		[wc.hIcon], eax
	mov		[wc.hIconSm], eax
	invoke	LoadCursor, NULL, IDC_ARROW
	mov		[wc.hCursor], eax
	invoke	RegisterClassEx, wc
	invoke	CreateWindowEx, WS_EX_CLIENTEDGE, ClassName, AppName, \
			WS_OVERLAPPEDWINDOW or WS_TABSTOP or WS_CLIPCHILDREN, CW_USEDEFAULT, \
			CW_USEDEFAULT, 600, 500, NULL, NULL, \
			[gIst], NULL
	mov		[gWnd], eax
	invoke	ShowWindow, [gWnd], SW_SHOWNORMAL
	invoke	UpdateWindow, [gWnd]
	.while TRUE
		invoke GetMessage, msg, NULL, 0, 0
		.if eax, e, 0
			jmp	@f
		.endif
		invoke	TranslateAccelerator, [gWnd], [hAccel], msg
		.if	eax, e, 0
			invoke	IsDialogMessage, [gWnd], msg
			.if eax, e, 0
				invoke TranslateMessage, msg
				invoke DispatchMessage, msg
			.endif
		.endif
	.endw
@@:
	mov	eax, [msg.wParam]
	invoke	ExitProcess, 0

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WndProc proc	hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
local	buffer[40]:BYTE
local	hdc:DWORD
local	Arect:DWORD
local	Abuffer:DWORD
local	wpTemp:DWORD
local	rect:RECT
local	ps:PAINTSTRUCT
local	tempItem:LVITEM
	.if [wmsg], e, WM_DESTROY
		invoke	PostQuitMessage, NULL
	.elseif [wmsg], e, WM_COMMAND
		mov	ecx, [lparam]
		mov	eax, [wparam]
		mov	edx, eax
		shr	edx, 16 				;high order wParam
		.if	dx, e, BN_CLICKED
			.if	ax, e, 25			;Go button
				invoke MessageBox, [hwnd], szButtonPressed, NULL, MB_OK
			.endif
		.endif
	.elseif [wmsg], e, WM_CREATE
		invoke	CreateWindowEx, WS_EX_CLIENTEDGE, ComboName, NULL, \
			WS_CHILD or WS_VISIBLE or WS_BORDER or \ 
				CBS_HASSTRINGS or CBS_DROPDOWNLIST or WS_VSCROLL or \
				CBS_SORT or WS_TABSTOP,\
			20, 30, 150, 425, [hwnd],14, [gIst], NULL
		mov	[hCB1], eax
		invoke	SendMessage, [hCB1], CB_ADDSTRING, 0, szFirst
		invoke	SendMessage, [hCB1], CB_ADDSTRING, 0, szSecond
		invoke SetFocus, [hCB1]

		invoke	CreateWindowEx, WS_EX_CLIENTEDGE, ListName, 0, \
				WS_CHILD or WS_VISIBLE or LVS_LIST or LVS_ALIGNLEFT or WS_TABSTOP or LVS_SORTASCENDING or WS_TABSTOP, \
				200, 30, 150, 105, [hwnd], 15, [gIst], NULL
		mov		[hLV1], eax
		invoke	SendMessage, [hLV1], \
				LVM_SETEXTENDEDLISTVIEWSTYLE, 0, LVS_EX_CHECKBOXES
		mov		[tempItem.mask], LVIF_TEXT or LVIF_STATE
		mov		[tempItem.iItem], 0
		mov		[tempItem.iSubItem], 0
		mov		[tempItem.stateMask], LVIS_STATEIMAGEMASK	OR LVIS_SELECTED 
		mov		[tempItem.state], ( 2 SHL 12)	OR LVIS_SELECTED
		mov		[tempItem.pszText], szFirst
		
		lea		eax, [tempItem]
		push	eax
		invoke	SendMessage, [hLV1], LVM_INSERTITEM, 0, eax
		pop		ecx
		invoke	SendMessage, [hLV1], LVM_SETITEMSTATE, eax, ecx
		inc		[tempItem.iItem]
		mov		[tempItem.pszText], szSecond
		lea		eax, [tempItem]
		push	eax
		invoke	SendMessage, [hLV1], LVM_INSERTITEM, 0, eax
		pop		ecx
		invoke	SendMessage, [hLV1], LVM_SETITEMSTATE, eax, ecx
		inc		[tempItem.iItem]
		mov		[tempItem.pszText], szThird
		lea		eax, [tempItem]
		invoke	SendMessage, [hLV1], LVM_INSERTITEM, 0, eax
		inc		[tempItem.iItem]
		mov		[tempItem.pszText], szFourth
		lea		eax, [tempItem]
		invoke	SendMessage, [hLV1], LVM_INSERTITEM, 0, eax
		inc		[tempItem.iItem]
		mov		[tempItem.pszText], szFifth
		lea		eax, [tempItem]
		invoke	SendMessage, [hLV1], LVM_INSERTITEM, 0, eax

		invoke	CreateWindowEx, WS_EX_CLIENTEDGE, EditName, NULL,\
			WS_CHILD or WS_VISIBLE or WS_BORDER or ES_LEFT or\
			ES_AUTOHSCROLL or WS_TABSTOP,\
			470, 6, 100, 25,[hwnd], 16, [gIst], NULL
		mov		[hEdit1], eax
		invoke	SetWindowText, [hEdit1], sz8
		invoke	CreateWindowEx, WS_EX_CLIENTEDGE, ComboName, NULL, \
				WS_CHILD or WS_VISIBLE or WS_BORDER or \ 
				CBS_HASSTRINGS or CBS_DROPDOWNLIST or WS_VSCROLL or \
				CBS_SORT or WS_TABSTOP,\
				20, 150, 150, 425, [hwnd], 20, [gIst], NULL
		mov		[hCB1], eax
		invoke	SendMessage, [hCB1], CB_ADDSTRING, 0, szNone
		invoke	SendMessage, [hCB1], CB_SETCURSEL, eax, 0

		invoke	CreateWindowEx, NULL, ButtonName, ButtonText, \
				WS_CHILD or WS_VISIBLE or BS_DEFPUSHBUTTON or WS_TABSTOP, \
				375, 370, 140, 25, [hwnd], 25, [gIst], NULL
		mov		[hButn], eax

		invoke	CreateWindowEx, NULL, ButtonName, CheckText, BS_MULTILINE or \
				WS_CHILD or WS_VISIBLE or WS_CLIPCHILDREN or BS_AUTOCHECKBOX or WS_TABSTOP, \
				375, 150, 300, 50, [hwnd], 26, [gIst], NULL
		mov		[hCheck], eax

		invoke	SetFocus, [hCB1]

	.else
		invoke	DefWindowProc, [hwnd], [wmsg], [wparam], [lparam]
		jmp		.dir_out
	.endif
	xor		eax, eax
.dir_out:
	ret
WndProc endp




section '.data' 	data		readable	writeable
	IncludeAllGlobals 

section '.idata'	import data readable writeable

	library kernel32,	'kernel32', \
			user32, 	'user32', \
			comctl32,	'comctl32', \
			gdi32,		'gdi32'

	include '\progra~1\fasm\include\apia\kernel32.inc'
	include '\progra~1\fasm\include\apia\user32.inc'
	include '\progra~1\fasm\include\apia\comctl32.inc'
	include '\progra~1\fasm\include\apia\gdi32.inc'
